import java.util.ArrayList;

class Individus {
  // opinion de l'individus
  int opinion ;
  
  // position de l'individus
  float x, y;
  
  // distance de persception
  float D;
  
  // probabilité de changer d'opinion
  float pChange;
  
  /**************************************************
  * constructeur complet
  ***************************************************/
  Individus(int opinion, float D, float pChange, float x, float y) {
    this.opinion = opinion;
    
    this.D = D;
    this.pChange = pChange;
    
    this.x = x;
    this.y = y;
  }
  
  /**************************************************
  * constructeur aléatoire
  ***************************************************/
  Individus(float D, float pChange) {
    this(int(random(2)), D, pChange, random(width), random(height));
  }
  
  /**************************************************
  * constructeur aléatoire
  ***************************************************/
  Individus(float p0, float D, float pChange) {
    this(0, D, pChange, random(width), random(height));

    if (random(1.0) < p0)
      opinion = 0;
    else
      opinion = 1;
   }
    
  /**************************************************
  * change la position ou l'opinion de l'individus
  *
  * entree :
  *  - pop : population entiere
  ***************************************************/
  void upDate(Individus [] pop) {
    // liste des individus dont la distance <= D
    ArrayList<Individus> voisins = inferieur(pop);
    
    // l'un des voisins aléatoirement 
    if (voisins.size() > 0) {
      Individus voisin = voisins.get(int(random(voisins.size())));
    
      if (voisin.opinion != opinion) {
        if (random(1.0) < pChange)
          opinion = voisin.opinion;
        else 
          deplacement(voisin);      
      }
    }
  }

  /**************************************************
  * donne tous les individus dont la distance est inférieure à D
  *
  * entree :
  *  - pop : population entiere
  *
  * sortie :
  *  - liste des individus
  ***************************************************/
    // selon la version de java utiliser plutôt :
//  ArrayList<Individus> inferieur(Individus [] pop) {
  ArrayList inferieur(Individus [] pop) {
    // selon la version de java utiliser plutôt :
//     ArrayList<Individus> voisins = new ArrayList<Individus>();
     ArrayList voisins = new ArrayList();
     
     for(int i = 0; i < pop.length; i++) {
       if (pop[i] != this) 
         if (distance(this, pop[i]) <= D)
           voisins.add(pop[i]);
     }
     
     return voisins;
  }
 
  /**************************************************
  * calcule la distance entre 2 individus
  *
  * entree :
  *  - indiv : individus dont il faut calculer la distance
  *
  * sortie :
  *  - distance
  ***************************************************/
  float distance(Individus indiv1, Individus indiv2) {
    return sqrt( (indiv1.x - indiv2.x) * (indiv1.x - indiv2.x) 
      + (indiv1.y - indiv2.y) * (indiv1.y - indiv2.y) );
  }
  
  /**************************************************
  * deplace à l'opposé de indiv
  *
  * entree :
  *  - indiv : individus dont il faut s'éloingner
  *
  * sortie :
  *  - aucune
  ***************************************************/
  void deplacement(Individus indiv) {
    float d = distance(this, indiv);
    
     x = x + (x - indiv.x) / d * 5;
     y = y + (y - indiv.y) / d * 5;
  }
  
  /**************************************************
  * dessin de l'individus
  ***************************************************/
  void dessine() {
    if (opinion == 0)
      fill(255, 0, 0, 200);
    else  
      fill(0, 0, 255, 200);

    ellipse(x, y, 20, 20);
  }
  
}
